Effects are functorial, monadic, and applicative types that are designed to capture IO based side-effects.    

| Section          | Type                                                                       | Description                                                                                                                                                                                                                                                           |
|------------------|----------------------------------------------------------------------------|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| [`Aff`](Aff)     | [`Aff<A>`](Aff/#LanguageExt_0_Aff_1)                                       | Asynchronous IO.  Captures asynchronous effects, handles exceptions elegantly.                                                                                                                                                                                        |
| [`Aff`](Aff)     | [`Aff<RT, A>`](Aff/#LanguageExt_0_Aff_2)                                   | Asynchronous IO.  Captures asynchronous effects, handles exceptions elegantly, and has an injectable runtime (`RT`) which can provide configuration and dependency-injection                                                                                          |
| [`Eff`](Eff)     | [`Eff<A>`](Eff/#LanguageExt_0_Eff_1)                                       | Synchronous IO.  Captures synchronous effects, handles exceptions elegantly.                                                                                                                                                                                          |
| [`Eff`](Eff)     | [`Eff<RT, A>`](Eff/#LanguageExt_0_Eff_2)                                   | Synchronous IO.  Captures synchronous effects, handles exceptions elegantly, and has an injectable runtime (`RT`) which can provide configuration and dependency-injection                                                                                            |
| [`Pipes`](Pipes) | [`Proxy<RT, UOut, UIn, DIn, DOut, A>`](Pipes/#LanguageExt.Pipes_0_Proxy_6) | Base of all Pipes types - single type that unifies unidirectional bidirectional streaming channels.                                                                                                                                                                   |
| [`Pipes`](Pipes) | [`Producer<RT, OUT, A>`](Pipes/Producer)                                   | Producers yield.  Derived from `Proxy`, opens the downstream-out, closes all other channels                                                                                                                                                                           |
| [`Pipes`](Pipes) | [`Consumer<RT, IN, A>`](Pipes/Consumer)                                    | Consumers await.  Derived from `Proxy`, opens the upstream-in, closes all other channels                                                                                                                                                                              |
| [`Pipes`](Pipes) | [`Pipe<RT, IN, OUT, A>`](Pipes/Pipe)                                       | Pipes await _and_ yield.  Derived from `Proxy`, opens the upstream-in and downstream-out, closes all other channels                                                                                                                                                   |
| [`Pipes`](Pipes) | [`Client<RT, REQ, RES, A>`](Pipes/Client)                                  | Clients request.  Derived from `Proxy`, opens the upstream-in and upstream-out, closes all other channels                                                                                                                                                             |
| [`Pipes`](Pipes) | [`Server<RT, REQ, RES, A>`](Pipes/Server)                                  | Servers respond.  Derived from `Proxy`, opens the downstream-in and downstream-out, closes all other channels                                                                                                                                                         |
| [`Pipes`](Pipes) | [`Effect<RT, A>`](Pipes/Effect)                                            | Fused composition of: <ul> <li>`Producer`, `Pipe`, and `Consumer`</li><li>`Client`, `Pipe`, and `Server`.</li></ul>Resulting in a `Proxy` derived `Effect` that that has no external channels open (the effect is 'closed', meaning it's sound - and can be run)      |
